# LICENSE    This file is part of COPS
# LICENSE
# LICENSE    COPS is free software: you can redistribute it and/or modify
# LICENSE    it under the terms of the GNU General Public License as published by
# LICENSE    the Free Software Foundation, either version 3 of the License, or
# LICENSE    (at your option) any later version.
# LICENSE
# LICENSE    COPS is distributed in the hope that it will be useful,
# LICENSE    but WITHOUT ANY WARRANTY; without even the implied warranty of
# LICENSE    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# LICENSE    GNU General Public License for more details.
# LICENSE
# LICENSE    You should have received a copy of the GNU General Public License
# LICENSE    along with COPS.  If not, see <http://www.gnu.org/licenses/>.


package COPS::pwquality;
use strict;

sub entropy
{
  # This concept used to be a lot more complicated (2024-06-19)
  # However, the 'simple' version is ... more entropy is better!

  my $arg = shift;
  COPS::print::debug("Determining password entropy");

  if($arg->{'variants'})
  {
    my $bits = int(log($arg->{'variants'})/log(2));
    COPS::print::info("[COPS] ");
    $arg->{'wlsize'} and COPS::print::info("Dictionary size = $arg->{'wlsize'} words / ");
    $bits >= 1024 and $bits = ">1024";
    COPS::print::info(COPS::FUNC::number::commify($arg->{'variants'})." variants / $bits bits of entropy\n");
  }
  else
  {
     COPS::print::warn("[COPS] Cannot determine entropy size for a secret not generated by COPS")
  }
  return;
}

sub hibp
{
  my $arg = shift;
  COPS::print::debug("Checking HIBP");
  my $hibp = COPS::FUNC::check::hibp($arg);

  if($hibp == -1)
  {
    COPS::print::warn("[HIBP] Check failed due to missing perl modules");
  }
  elsif($hibp)
  {
    my $out = ({
        "type" => 'warn',
        "text" => "[HIBP] Password appears ${hibp} times at 'haveibeenpwned'",
        "colour" => 'error'
      });

    COPS::print::out($out);
  }
  else
  {
    COPS::print::info("[HIBP] Password does NOT appear at 'haveibeenpwned'.\n");
  }
  return;
}

1;
